#
# spec file for package rubygem-sexp_processor
#
# Copyright (c) 2024 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


#
# This file was generated with a gem2rpm.yml and not just plain gem2rpm.
# All sections marked as MANUAL, license headers, summaries and descriptions
# can be maintained in that file. Please consult this file before editing any
# of those fields
#

Name:           rubygem-sexp_processor
Version:        4.17.2
Release:        1.1
%define mod_name sexp_processor
%define mod_full_name %{mod_name}-%{version}
BuildRequires:  %{ruby < 4}
BuildRequires:  %{ruby >= 2.6}
BuildRequires:  %{rubygem gem2rpm}
BuildRequires:  %{rubygem rdoc > 3.10}
BuildRequires:  ruby-macros >= 5
URL:            https://github.com/seattlerb/sexp_processor
Source:         https://rubygems.org/gems/%{mod_full_name}.gem
Source1:        gem2rpm.yml
Summary:        sexp_processor branches from ParseTree bringing all the generic sexp
License:        MIT

%description
sexp_processor branches from ParseTree bringing all the generic sexp
processing tools with it. Sexp, SexpProcessor, Environment, etc... all
for your language processing pleasure.

%prep

%build

%install
%gem_install \
  --doc-files="History.rdoc README.rdoc" \
  -f
# MANUAL
perl -p -i -e 's|#!\S+|#!/usr/bin/ruby|g' %{buildroot}%{_libdir}/*/gems/*/gems/%{mod_full_name}/test/*
# /MANUAL

%gem_packages

%changelog
* Tue Jul 16 2024 Dan Čermák <dan.cermak@posteo.net>
- New upstream release 4.17.2, see bundled History.rdoc
* Mon Jan 29 2024 Dan Čermák <dan.cermak@posteo.net>
- New upstream release 4.17.1, see bundled History.rdoc
* Tue Nov 14 2023 Dan Čermák <dan.cermak@posteo.net>
- New upstream release 4.17.0, see bundled History.rdoc
* Thu Apr 28 2022 Stephan Kulow <coolo@suse.com>
  updated to version 4.16.1
  see installed History.rdoc
  === 4.16.1 / 2022-04-09
  * 1 minor enhancement:
  * Reworked ParseTreeTestCase's notion of versions to make it easier to extend.
* Tue Jan 25 2022 Stephan Kulow <coolo@suse.com>
  updated to version 4.16.0
  see installed History.rdoc
  === 4.16.0 / 2021-10-27
  * 4 minor enhancements:
  * Added Sexp#value (pushed up from ruby_parser).
  * Aliased Sexp#concat to #_concat and use that so it can be overridden.
  * Cache the #hash result.
  * StrictSexp mode (4) now covers concat.
  * 3 bug fixes:
  * Fix some doco on each_sexp to clarify that it is not recursive.
  * Fixed a bug calling enum_for when using each_of_type w/ no block.
  * Minor fixes to pt_testcase.rb for custom timeouts and better error handling.
* Thu Jun 24 2021 Stephan Kulow <coolo@suse.com>
  updated to version 4.15.3
  see installed History.rdoc
  === 4.15.3 / 2021-05-15
  * 1 minor enhancement:
  * Added 3.0 to pt_testcase.rb
* Wed Jan 20 2021 Stephan Kulow <coolo@suse.com>
  updated to version 4.15.2
  see installed History.rdoc
  === 4.15.2 / 2021-01-10
  * 1 bug fix:
  * Bumped ruby version to include < 4 (trunk).
* Fri Sep 25 2020 Stephan Kulow <coolo@suse.com>
  updated to version 4.15.1
  see installed History.rdoc
  === 4.15.1 / 2020-08-31
  * 1 bug fix:
  * Bumped ruby version to include 3.0 (trunk).
  === 4.15.0 / 2020-06-09
  * 1 minor enhancement:
  * Added `child` and `include` to Sexp::Matcher.parse language.
* Mon Feb 10 2020 Stephan Kulow <coolo@suse.com>
- updated to version 4.14.1
  see installed History.rdoc
  === 4.14.1 / 2020-02-09
  * 2 bug fixes:
  * Declared support for ruby 2.2+ to gemspec.
  * Fixed alias for `not?` to `-` for ruby <= 2.4. (nard-tech).
  === 4.14.0 / 2020-02-06
  * 4 minor enhancements:
  * Added '-' as an alias for the 'not?' pattern matching command.
  * Added Klass matcher to match on types.
  * Added `k` shortcut for Klass & hooked into Sexp::Matcher.parse.
  * Added any matcher to pattern parser.
  === 4.13.0 / 2019-09-24
  * 4 minor enhancements:
  * Added Sexp.q (query) and deprecated Sexp.s to distinguish better and match inspect output.
  * Extended Sexp::Matcher::Parser to allow `not?` patterns.
  * Extended Sexp::Matcher::Parser to cover more method names.
  * Split out all pattern-oriented code to sexp_matcher.rb.
  * 1 bug fix:
  * Fixed bug w/ ruby's Array#eql? and #hash not looking at ivars.
* Fri Jul 19 2019 Stephan Kulow <coolo@suse.com>
- updated to version 4.12.1
  see installed History.rdoc
  === 4.12.1 / 2019-06-03
  * 1 minor enhancement:
  * Sexp#line now raises if setting w/ non-integer (eg nil).
  * 3 bug fixes:
  * Fixed pt_testcase.rb for block args w/ trailing commas.
  * Fixed pt_testcase.rb for stabby proc sexps.
  * Simple fixes for STRICT_SEXP=1.
* Thu Mar 14 2019 Stephan Kulow <coolo@suse.com>
- updated to version 4.12.0
  see installed History.rdoc
  === 4.12.0 / 2019-03-12
  * 3 bug fixes:
  * Fixed sexp_body to return empty sexp instead of nil when using STRICT_SEXP.
  * STRICT_SEXP=4+ fails w/ current use of concat. Removed concat from strictness for now.
  * Use concat internally instead of splat. Some people have 20000 node sexps! (presidentbeef)
* Wed Apr 11 2018 factory-auto@kulow.org
- updated to version 4.11.0
  see installed History.rdoc
  === 4.11.0 / 2018-04-05
  * 1 minor enhancement:
  * Extended deep_each to skip subtrees if block returns :skip.
* Thu Feb 15 2018 bgeuken@suse.com
- Update to version 4.10.1
  * 1 minor enhancement:
  * Tweaked pt_testcase for ruby 2.5 and better ruby2ruby test data.
* Thu Aug  3 2017 coolo@suse.com
- updated to version 4.10.0
  see installed History.txt
  === 4.10.0 / 2017-07-17
  * 2 major enhancements:
  * Added experimental pattern matcher to Sexp. Forked from sexp_path.
  * Extended s to take a block and return a matcher: eg s{ s(:defn, atom, _, ___) }
  * 23 minor enhancements:
  * Added $STRICT_SEXP to crank down Sexp.[] and friends.
  * Added Matcher#/ w/ real functionality.
  * Added Sexp#/ to search with new patterns.
  * Added Sexp#map to ensure you get a Sexp back.
  * Added Sexp#new to create a new sexp with the same file/line/comment info.
  * Added Sexp#search_each to recursively search w/ new patterns. Returns enum if no block.
  * Added Sexp#sexp_body=
  * Added Sexp::Matcher.match_subs? and .match_subs= to extend =~ so you can match strictly.
  * Added Sexp::Matcher.parse to convert lispy string to safe matcher: "(defn atom _ ___)"
  * Added all mutation methods to STRICT_SEXP >= 4
  * Added deprecation message to Sexp#structure for [s(...)] forms.
  * Added strict_sexp.rb to help you clamp down for future changes. STRICT_SEXP=1+
  * Auto-require strict_sexp if $STRICT_SEXP is > 0.
  * Converted a lot of indexed access to sexp_type/sexp_body, etc.
  * Finally enforced SexpProcessor#process to only process sexps, not bare arrays.
  * Made Sexp#/ double-dispatch to Matcher#/.
  * Made Sexp#gsub work with new patterns.
  * Made Sexp#sub work with new patterns.
  * Made SexpProcessor STRICT_SEXP=4 compliant.
  * Retired SexpMatchSpecial & SexpAny. Never used by anything AFAICT.
  * Sexp#=== goes back to default.
  * Sexp#=~(pat) calls pat =~ self.
  * Sexp#sexp_body now takes optional offset. Use instead of sexp[n..-1].
  * 9 bug fixes:
  * Extended Sexp::Matcher::Parser.parse to lex more forms of regexp.
  * Finished off all missing doco.
  * Fixed == methods on all Matcher classes to include ivars.
  * Fixed Child#satisfy? to properly return false if failed.
  * Fixed Sexp#sexp_body to return a sexp using Sexp#new.
  * Fixed map to use Sexp#new.
  * Only try to set c_type if it responds to it. Make STRICT_SEXP safe.
  * R2C has a hack in SexpProcessor to call sexp_type=. Renamed to c_type= in R2C.
  * Removed very obsolete attrset test from pt_testcase.rb
  === 4.10.0b1 / 2017-06-13
  Beta of the above.
* Fri Apr 14 2017 coolo@suse.com
- updated to version 4.9.0
  see installed History.txt
  === 4.9.0 / 2017-04-13
  * 9 minor enhancements:
  * Added Sexp.depth
  * Added Sexp.sexp_type=
  * Cache Sexp.line_max. Massively speeds up large flay runs.
  * Cleaned up SexpProcessor.process handling of result node type.
  * Extend pt_testcase for ruby 2.4 tests.
  * Extended Sexp.method_missing to only print on every invocation if $VERBOSE=1
  * Extended Sexp.method_missing to warn if the expected sub-sexp is not found.
  * Rewrote Sexp.mass to be MUCH faster. Helps tremendously with flay on large files.
  * Warn that Sexp#method_missing was tripped if $DEBUG.
* Thu Feb  2 2017 coolo@suse.com
- updated to version 4.8.0
  see installed History.txt
  === 4.8.0 / 2017-02-01
  * 2 minor enhancements:
  * Added Sexp#line_max
  * Extended MethodBasedSexpProcessor#in_method to take line_max and record span.
* Fri Feb 19 2016 coolo@suse.com
- updated to version 4.7.0
  see installed History.txt
  === 4.7.0 / 2016-02-18
  * 2 minor enhancements:
  * Expand to support 2.3 in tests. (presidentbeef)
  * Return enumerable for deep_each, each_sexp, and each_of_type. (ridiculous)
* Mon Jan 25 2016 coolo@suse.com
- updated to version 4.6.1
  see installed History.txt
  === 4.6.1 / 2016-01-21
  * 1 bug fix:
  * defs should have a nil node if body is empty.
* Fri May 29 2015 coolo@suse.com
- updated to version 4.6.0
  see installed History.txt
  === 4.6.0 / 2015-05-28
  * 2 minor enhancements:
  * Extended generate_test to deal with 19 and up.
  * Extended pt_testcase.rb so add_19tests means 19 and up.
  * 1 bug fix:
  * Added and normalized tests to deal with canonicalized block args from ruby_parser.
* Tue Apr 28 2015 coolo@suse.com
- updated to version 4.5.1
  see installed History.txt
  === 4.5.1 / 2015-04-27
  * 1 minor enhancement:
  * Cache processors and rewriters. Significant speedup. (presidentbeef)
* Mon Mar 16 2015 coolo@suse.com
- updated to version 4.5.0
  * 1 minor enhancement:
  * Added SexpProcessor::expand_dirs_to_files as a utility to cmdline tools.
* Tue Feb 10 2015 coolo@suse.com
- updated to version 4.4.5
* Sun Oct 12 2014 coolo@suse.com
- updated to version 4.4.4
  * 1 bug fix:
  * MethodBasedSexpProcessor#in_klass clears out the method_stack for the duration of the block.
* Wed Sep 10 2014 mrueckert@suse.de
- added gem2rpm.yml as source
* Wed Sep 10 2014 mrueckert@suse.de
- added a small scriptlet to fix the shebang line of the test
  scripts.
- also added a gem2rpm.yml for later, but did not regenerate the
  specfile just yet.
* Sun Apr  6 2014 coolo@suse.com
- updated to version 4.4.3
  * 1 bug fix:
  * Fixed a bunch of pt_testcase entries for 1.9/2.0 wrt ruby2ruby.
* Tue Mar 18 2014 coolo@suse.com
- updated to version 4.4.2
  * 2 minor enhancements:
  * Changed skipped versioned tests to return, not skip. Reduces noise so you can focus on real skips.
  * Extended versioned tests to include 2.0 and 2.1.
* Mon Dec 16 2013 coolo@suse.com
- updated to version 4.4.1
  * 1 bug fix:
  * Added parenthesis to fix the structure_remove_begin_1 testcase. (bocete)
* Sun Oct 20 2013 coolo@suse.com
- updated to version 4.4.0
  * Added MethodBasedSexpProcessor, extracted from Flog.
* Mon Aug 26 2013 coolo@suse.com
- updated to version 4.3.0
  * 1 minor enhancement:
  * Switched ParseTreeTestCase to minitest 5.
* Sat Apr 13 2013 coolo@suse.com
- updated to version 4.2.1
  * 1 bug fix:
  * Removed structure_unused_literal_wwtt because I just don't care anymore
* Wed Mar 20 2013 coolo@suse.com
- updated to version 4.2.0
  * 2 minor enhancements:
  * Added SexpInterpreter since it is such a common pattern
  * Added aliases Sexp#head & Sexp#rest for readability
* Sun Mar  3 2013 coolo@suse.com
- updated to version 4.1.5
  * Clarified role of s method. Fixes #12.
  * maglev: Workaround for bug in Array#shift
* Wed Jan 23 2013 coolo@suse.com
- updated to version 4.1.4
  * 1 minor enhancement:
  * Gave Sexp#structure a ~10%% boost
  * 2 bug fixes:
  * Fixed Sexp#mass lying when using auto_shifted sexps.
  * Stupid fix for ruby 2.0 method_missing 'bug'.
* Fri Dec  7 2012 coolo@suse.com
- updated to version 4.1.3
  * Code cleanup... what was I thinking???
  * Explicitly setting pt_testcase.rb to US-ASCII to avoid encoding hell
* Sun Nov  4 2012 coolo@suse.com
- updated to version 4.1.2
  * Sexp#structure should grep for Sexps, not Arrays
* Sat Nov  3 2012 coolo@suse.com
- updated to version 4.1.1
  * iter args revamp for ruby_parser 3 changes.
* Sun Oct 28 2012 coolo@suse.com
- updated to version 4.1.0
  * Added Environment#current so you can explicitly shadow variables. (meh)
* Sun Jul 15 2012 coolo@suse.com
- update to 4.0.1
  * 4 bug fixes:
  * 1.9: Changed !@ to ! since that is what you implement
  * True to my wtf comment, there was a bug in my case_splat test
  * Fixed a bunch of entries for r2r changes against edgecase parse/lex tests
  * Fixes for R2R
  * 5 major enhancements:
  * Removed :arglist from everything except :op_asgn1.
  * Removed block from resbody
  * Removed block from when node
  * Removed block nodes inside of scope nodes (defn/defs/class/sclass).
  * Removed scope nodes in defn/defs/class/sclass nodes.
  * 10 minor enhancement:
  * 1.9: Had to version split all my 'not' tests since 1.9 is insane.
  * 1.9: f (args) is not allowed in 1.9.
  * 1.9: f(hash, *splat) is not allowed in 1.9.
  * Added module2 test to verify module w/ 2+ entities
  * Added Sexp#deep_each and Sexp#each_sexp. Refactored from Flay
  * Added a ton of block arg tests.
  * Added add19_edgecases to help refactor a bunch of tests that all have the same output.
  * Added better debugging output for rewrites.
  * Cleaned and added a bunch of stabby proc tests.
  * Moved RawParseTree test data to ParseTree project.
* Thu Mar 22 2012 saschpe@suse.de
- Update to version 3.1.0:
  * Added test_call_arglist_trailing_comma__19 (presidentbeef)
  * Added test_fcall_inside_parens. (presidentbeef)
  * Added test_if_args_no_space_symbol__18. (presidentbeef)
  * Added tests for new hash syntax and ternaries in 1.9 (lastobelus)
* Mon Sep  6 2010 mrueckert@suse.de
- update to version 3.0.5
  * Added in_context to clean up code.
  * optimize inspect to avoid needlessly caching @line
* Mon Jun 14 2010 mrueckert@suse.de
- update to version 3.0.4
  * Added line number to pretty_print output if $VERBOSE
* Fri Jun 11 2010 mrueckert@suse.de
- use rubygems_requires macro
* Fri Dec 25 2009 prusnak@suse.cz
- updated to 3.0.3
* Mon Mar 23 2009 mrueckert@suse.de
- fix build
* Sat Jan 31 2009 dmacvicar@suse.de
- initial package
